﻿Type=StaticCode
Version=5.02
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Type typViewCmnProp(LeftPerc As Float, _
						TopPerc As Float, _
						WidthPerc As Float, _
						HeightPerc As Float)


	Type typViewProp(ViewName As String, _
					 ViewType As String, _
					 CmnProp As typViewCmnProp)
	
	Private mWriter As TextWriter
	
	Private mPath As String

End Sub

Public Sub Init(Path As String, FileName As String)
	If mWriter.IsInitialized Then Return
	mPath = Path
	mWriter.Initialize(File.OpenOutput(mPath, FileName, False))
End Sub

Sub GeneratePercLayoutCode(Parent As Panel, ParentName As String)

	Dim CodeBlocks As Map
	Dim DimViewsCodeLines As List
	Dim AddViewsCodeLines As List

	CodeBlocks.Initialize
	DimViewsCodeLines.Initialize
	AddViewsCodeLines.Initialize

	' In fact, it writes the intial Activity devider line
	DimViewsCodeLines.Add(CRLF & "@@@@@@@@@@@@@@@@@@@@@     " & ParentName & "     @@@@@@@@@@@@@@@@@@@@@" & CRLF)

	DimViewsCodeLines.Add("#Region  * VIEWS DECLARATION  ")
	
	AddViewsCodeLines.Add("#Region * VIEWS ADDITION  ")
	
	Gencode(Parent, ParentName, CodeBlocks, DimViewsCodeLines, AddViewsCodeLines)
	
	DimViewsCodeLines.Add("#EndRegion" & CRLF)
	CodeBlocks.Put("DimViews", DimViewsCodeLines)

	AddViewsCodeLines.Add("#EndRegion" & CRLF)
	CodeBlocks.Put("AddViews", AddViewsCodeLines)

	' In fact, it writes the Activity devider end line
	AddViewsCodeLines.Add("______________     End of " & ParentName & "     _____________________" & CRLF)

	SavePercLayout(CodeBlocks)
End Sub


Sub Gencode(Parent As Panel, ParentName As String, CodeBlocks As Map, DimViewsCodeLines As List, AddViewsCodeLines As List)
	Dim vw As View
	Dim ViewType As String
	Dim TypeString As String
	
	DimViewsCodeLines.Add(CRLF & TAB & "' " & ParentName & " content.")
	AddViewsCodeLines.Add(CRLF & TAB & "' " & ParentName)
	Dim LastDotPos As Int

	For I = 0 To Parent.NumberOfViews-1
		Dim ViewProp As typViewProp
		ViewProp.Initialize

		vw = Parent.GetView(I)

		If vw Is Panel Then
			ViewType = "Panel"
		Else
			TypeString = GetType(vw)
			LastDotPos = TypeString.LastIndexOf(".")
			ViewType = TypeString.SubString(LastDotPos + 1)
		End If
		ViewProp.ViewType = ViewType

		' Name - shuld be used reflection!
		ViewProp.ViewName = vw.tag

		CalcPerc(vw, ViewProp, Parent.Width, Parent.Height)
		AddCodeLine(ViewProp, ParentName, DimViewsCodeLines, AddViewsCodeLines)

		If vw Is Panel Then
			Gencode(vw, ViewProp.ViewName, CodeBlocks, DimViewsCodeLines, AddViewsCodeLines)
		End If
	Next
	
End Sub

Sub CalcPerc(vw As View, ViewProp As typViewProp, ActWidth As Int, ActHeight As Int)
	' - Left
	ViewProp.CmnProp.LeftPerc = (vw.Left / ActWidth) * 100
	' - Top
	ViewProp.CmnProp.TopPerc = (vw.Top / ActHeight) * 100
	' - Width
	ViewProp.CmnProp.WidthPerc = (vw.Width / ActWidth) * 100
	' - Height
	ViewProp.CmnProp.HeightPerc = (vw.Height / ActHeight) * 100
End Sub

Sub AddCodeLine(ViewProp As typViewProp, ParentName As String, _
				DimViewsCodeLines As List, _
				AddViewsCodeLines As List)

	Dim CodeLine As String

	' View declaration
	CodeLine = TAB
	CodeLine = CodeLine & "Dim " & ViewProp.ViewName & " As " & ViewProp.ViewType
	DimViewsCodeLines.Add(CodeLine)
	
	' View addition
	CodeLine = TAB
	
	CodeLine = CodeLine & ParentName & ".AddView(" & ViewProp.ViewName _
																  & ", " & NumberFormat(ViewProp.CmnProp.LeftPerc, 1, 3) & "%x" _
																  & ", " & NumberFormat(ViewProp.CmnProp.TopPerc, 1, 3) & "%y" _
																  & ", " & NumberFormat(ViewProp.CmnProp.WidthPerc, 1, 3) & "%x" _
																  & ", " & NumberFormat(ViewProp.CmnProp.HeightPerc, 1, 3) & "%y" _
																  & ")" ' & CRLF
	AddViewsCodeLines.Add(CodeLine)
End Sub


Sub SavePercLayout(CodeBlocks As Map)
	Log("Snippet...")
	Dim CodeLine As String
	For i = 0 To CodeBlocks.Size-1
		Dim CodeBlock As List
		CodeBlock = CodeBlocks.GetValueAt(i)
		For j = 0 To CodeBlock.Size-1
			CodeLine = CodeBlock.Get(j)
			Log(CodeLine)
			mWriter.WriteLine(CodeLine)
		Next
	Next
End Sub


Public Sub Close
	mWriter.Close
End Sub